%define ALD_Ver		1.2.1

Name:         cups

License:      GPL LGPL
Summary:      Common UNIX Printing System
Group:        System Environment/Daemons
Version:      1.4.8
Release:      1

Url: http://www.cups.org

Source: %{name}-%{version}-source.tar.xz
Source1: CROSS.sh
Patch0: cups-busybox_ps.patch

%define DestDir		/ps_pdf_printer

# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64/armv6l/win32 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%define target %{_arch}-%{_vendor}-%{_os}%{__isa_bits}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif
%define target_  %{target}-

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin

%define __os_install_post %{nil}

%define cross_bindir	%{csysdir}%{_bindir}
%define cross_sbindir	%{csysdir}%{_sbindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{name}

# ------------------- description ------------------------------------
%description
The Common UNIX Printing System provides a portable printing layer for 
UNIX operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces. 
#-------------------------------
%package de
Summary: Common UNIX Printing System - German support
Group: System Environment/Daemons
%description de
Common UNIX Printing System - German support
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package locale
Summary:      locale
Group:        Applications/Languages
%description locale
Locale
#-------------------------------
%package ppdc
Summary:      ppdc - cups ppd compiler (use c++ !!!)
Group:        Documentation
%description ppdc
ppdc compiles PPDC source  files  into  one  or  more  PPD files.
#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}
%patch0 -b .orig -p0

# ------------------- Build ------------------------------------------
%Build 

%if %{_CROSS}

OPTFLAGS="-O2"
CFLAGS="$OPTFLAGS"
CXXFLAGS="$OPTFLAGS"
LDFLAGS=" "

#sed -i s:"@PIEFLAGS@":: Makedefs.in

%configure \
	--with-optim="$OPTFLAGS" \
	--disable-debug \
	--disable-dbus \
	--enable-libpaper \
	--disable-relro \
	--enable-pap \
	&>FConfigure_log-i386.txt

make &>FMake_log-i386.txt

mv man/mantohtml man/mantohtml-i386
mv ppdc/genstrings ppdc/genstrings-i386

make clean >/dev/null

PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath

export ac_cv_path_PKGCONFIG="%{csysbindir}/%{target}-pkg-config"
export ac_cv_path_AR="%{csysbindir}/%{target}-ar"
export ac_cv_path_LD="%{csysbindir}/%{target}-ld"

%else  #_CROSS
export PATH=$PATH:/opt/perl/bin
%endif #!_CROSS

#sed -i s:"\$exec_prefix/lib/cups":"%{_libdir}/cups": configure
#sed -i s:"/usr/lib/cups":"%{_libdir}/cups": config.h.in

%if %{_lib} != "lib"
sed -i s:"exec_prefix/lib/cups":"exec_prefix/%{_lib}/cups": configure
%endif

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 -fno-asynchronous-unwind-tables"
%endif
%if %{_arch} == "arm"
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif

CFLAGS="$OPTFLAGS -std=gnu99"
CXXFLAGS="$OPTFLAGS"
%if 0
GCC_VER_STR=`%{target_}gcc -dumpversion`
LDFLAGS=`case $GCC_VER_STR in \
 4.[56789].*) echo -static-libgcc -static-libstdc++;; \
 esac`
%endif
LDFLAGS=" "

%configure \
	--build=%{_build} \
%if %{_CROSS}
	--host=%{target} \
%endif
	--with-optim="$OPTFLAGS" \
	--enable-shared \
	--disable-static \
	--disable-debug \
	--enable-libpaper \
	--disable-relro \
	--enable-pap \
	&>FConfigure_log.txt

%if %{_CROSS}
sed -i s:"./mantohtml":"./mantohtml-i386": man/Makefile
sed -i s:"./genstrings":"./genstrings-i386": ppdc/Makefile

sed -i s:"-I/usr/include":"-I%{cross_includedir}": Makedefs
sed -i s:"-I/usr/lib":"-I%{cross_libdir}": Makedefs
%endif

sed -i s/".SILENT:"// Makedefs
sed -i s:"-fPIE -pie ":: Makedefs

make &>FMake_log.txt


# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

#rm -rf $RPM_BUILD_ROOT
#mkdir -p $RPM_BUILD_ROOT
make BUILDROOT=$RPM_BUILD_ROOT install &>FInstall_log.txt
rm -r $RPM_BUILD_ROOT/etc/rc0.d
rm -r $RPM_BUILD_ROOT/etc/rc2.d
rm -r $RPM_BUILD_ROOT/etc/rc3.d
rm -r $RPM_BUILD_ROOT/etc/rc5.d

rm -f $RPM_BUILD_ROOT/etc/cups/cupsd.conf
mv -f $RPM_BUILD_ROOT/etc/cups/snmp.conf $RPM_BUILD_ROOT/etc/cups/snmp.conf.default
#rm -rf $RPM_BUILD_ROOT/etc/dbus-1

cp CREDITS.txt LICENSE.txt README.txt $RPM_BUILD_ROOT%{docdir}/

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=%{BUILD_LOCAL_CROSS}
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%if %{BUILD_LOCAL_CROSS}
mkdir -p $RPM_BUILD_ROOT%{csysdir}/bin
mv $RPM_BUILD_ROOT%{cross_bindir}/cups-config $RPM_BUILD_ROOT%{csysdir}/bin
#sed -i s:"=/usr/include":"%{cross_includedir}": $RPM_BUILD_ROOT%{csysdir}/bin/cups-config
rm -r $RPM_BUILD_ROOT%{csysdir}/etc
rm -r $RPM_BUILD_ROOT%{csysdir}/var
rm -r $RPM_BUILD_ROOT%{cross_bindir}
rm -r $RPM_BUILD_ROOT%{cross_sbindir}
rm -r $RPM_BUILD_ROOT%{cross_libdir}/cups
rm -r $RPM_BUILD_ROOT%{cross_datadir}
mkdir -p $RPM_BUILD_ROOT%{cross_docdir}
cp CREDITS.txt LICENSE.txt README.txt $RPM_BUILD_ROOT%{cross_docdir}/
%endif #BUILD_LOCAL_CROSS
%endif #_CROSS

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean 

DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-ppdc-$SE $DD/%{name}-ppdc-$DE
  mv %{name}-devel-$SE $DD/%{name}-devel-$DE
  mv %{name}-locale-$SE $DD/%{name}-locale-$DE
  mv %{name}-de-$SE $DD/%{name}-de-$DE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
%endif #BUILD_LOCAL_CROSS
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%if %{BUILD_LOCAL_CROSS}
  TMP_TO=$DDC/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{TO_ARCH}-%{version}-%{release}.%{_build_cpu}
  mkdir -p $tmp
  cp -r cross $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%endif
popd
%endif  #BUILD_TAR

%post
if test ! -e /etc/cups/cupsd.conf; then
  cp /etc/cups/cupsd.conf.default /etc/cups/cupsd.conf
fi
if test ! -e /etc/cups/snmp.conf; then
  cp /etc/cups/snmp.conf.default /etc/cups/snmp.conf
fi


# ------------------- Files ------------------------------------------
%Files
%{_sysconfdir}/cups
%{_sysconfdir}/init.d
%{_sysconfdir}/dbus-1
%{_bindir}/cancel
%{_bindir}/cupstestdsc
%{_bindir}/cupstestppd
%{_bindir}/lp*

%exclude %{_libdir}/libcupsppdc.so.*
%{_libdir}/*.so.*
%{_libdir}/cups/backend
%{_libdir}/cups/cgi-bin
%{_libdir}/cups/daemon/cups-deviced
%{_libdir}/cups/daemon/cups-lpd
%{_libdir}/cups/daemon/cups-polld
%{_libdir}/cups/filter
%{_libdir}/cups/monitor
%{_libdir}/cups/notifier
%{_libdir}/cups/driver

%{_sbindir}

%{_datadir}/applications
%{_datadir}/cups/banners
%{_datadir}/cups/charmaps/iso*
%{_datadir}/cups/charmaps/koi8-r.txt
%{_datadir}/cups/charmaps/koi8-u.txt
%{_datadir}/cups/charmaps/mac-roman.txt
%{_datadir}/cups/charmaps/windows-125*
%{_datadir}/cups/charmaps/windows-1361.txt
%{_datadir}/cups/charmaps/windows-874.txt
%{_datadir}/cups/charmaps/windows-950.txt
%{_datadir}/cups/charsets
%{_datadir}/cups/data
%{_datadir}/cups/fonts
%{_datadir}/cups/mime
%{_datadir}/cups/model
%{_datadir}/cups/profiles
%{_datadir}/cups/templates/*.*


%{_defaultdocdir}/cups/*.*
%{_defaultdocdir}/cups/help/accounting.html
%{_defaultdocdir}/cups/help/cgi.html
%{_defaultdocdir}/cups/help/glossary.html
%{_defaultdocdir}/cups/help/kerberos.html
%{_defaultdocdir}/cups/help/license.html
%{_defaultdocdir}/cups/help/man*
%{_defaultdocdir}/cups/help/network.html
%{_defaultdocdir}/cups/help/options.html
%{_defaultdocdir}/cups/help/overview.html
%{_defaultdocdir}/cups/help/policies.html
%{_defaultdocdir}/cups/help/ref-access_log.html
%{_defaultdocdir}/cups/help/ref-classes-conf.html
%{_defaultdocdir}/cups/help/ref-client-conf.html
%{_defaultdocdir}/cups/help/ref-cupsd-conf.html
%{_defaultdocdir}/cups/help/ref-error_log.html
%{_defaultdocdir}/cups/help/ref-mailto-conf.html
%{_defaultdocdir}/cups/help/ref-page_log.html
%{_defaultdocdir}/cups/help/ref-printers-conf.html
%{_defaultdocdir}/cups/help/ref-snmp-conf.html
%{_defaultdocdir}/cups/help/ref-subscriptions-conf.html
%{_defaultdocdir}/cups/help/security.html
%{_defaultdocdir}/cups/help/spec*
%{_defaultdocdir}/cups/help/standard.html
%{_defaultdocdir}/cups/help/translation.html
%{_defaultdocdir}/cups/help/whatsnew.html
%{_defaultdocdir}/cups/help/postscript-driver.html
%{_defaultdocdir}/cups/help/raster-driver.html
%{_defaultdocdir}/cups/help/sharing.html

%{_defaultdocdir}/cups/images
%{_datadir}/icons

%{_mandir}/man1
%{_mandir}/man5
%{_mandir}/man8
/var

%files devel
%{_bindir}/cups-config
%{_includedir}
%{_libdir}/*.so
%{_mandir}/man7
%{_defaultdocdir}/cups/help/api*

%files de
%{_datadir}/cups/templates/de
%{_defaultdocdir}/cups/de
%{_datadir}/locale/de

%files locale
%{_datadir}/cups/charmaps/euc-cn.txt
%{_datadir}/cups/charmaps/euc-jp.txt
%{_datadir}/cups/charmaps/euc-kr.txt
%{_datadir}/cups/charmaps/euc-tw.txt
%{_datadir}/cups/charmaps/jis-x0213.txt
%{_datadir}/cups/charmaps/windows-932.txt
%{_datadir}/cups/charmaps/windows-936.txt
%{_datadir}/cups/charmaps/windows-949.txt

%{_datadir}/cups/templates/es
%{_datadir}/cups/templates/eu
%{_datadir}/cups/templates/id
%{_datadir}/cups/templates/it
%{_datadir}/cups/templates/ja
%{_datadir}/cups/templates/pl
%{_datadir}/cups/templates/ru
%{_datadir}/locale/da
%{_datadir}/locale/es
%{_datadir}/locale/eu
%{_datadir}/locale/fi
%{_datadir}/locale/fr
%{_datadir}/locale/id
%{_datadir}/locale/it
%{_datadir}/locale/ko
%{_datadir}/locale/nl
%{_datadir}/locale/no
%{_datadir}/locale/ja
%{_datadir}/locale/pl
%{_datadir}/locale/pt
%{_datadir}/locale/pt_BR
%{_datadir}/locale/ru
%{_datadir}/locale/sv
%{_datadir}/locale/zh
%{_datadir}/locale/zh_TW
%{_defaultdocdir}/cups/es
%{_defaultdocdir}/cups/eu
%{_defaultdocdir}/cups/id
%{_defaultdocdir}/cups/it
%{_defaultdocdir}/cups/ja
%{_defaultdocdir}/cups/ru
%{_defaultdocdir}/cups/pl

%files ppdc
%{_bindir}/ppd*
%{_libdir}/libcupsppdc.so.*
%{_libdir}/cups/daemon/cups-driverd
%{_defaultdocdir}/cups/help/ppd-compiler.html
%{_defaultdocdir}/cups/help/ref-ppdcfile.html
%{_datadir}/cups/drv
%{_datadir}/cups/examples
%{_datadir}/cups/ppdc

# ------------------- Cross Files ------------------------------------
%if %{BUILD_LOCAL_CROSS}

%files %{TO_ARCH}
%{csysbindir}
%{cross_libdir}
%{cross_includedir}
%{cross_docdir}

%endif #!BUILD_LOCAL_CROSS
